(function ($, Modernizr, Drupal) {

  function getLangcode() {
    return drupalSettings && drupalSettings.calendar_systems && drupalSettings.calendar_systems.lang
      ? (drupalSettings.calendar_systems.lang === "fa" ? "fa" : "en")
      : "en";
  }

  function storePd(elementId, pd) {
    if (!drupalSettings.calendar_systems) {
      drupalSettings.calendar_systems = {};
    }
    if (!drupalSettings.calendar_systems.pd) {
      drupalSettings.calendar_systems.pd = [];
    }
    if (drupalSettings.calendar_systems.pd[elementId]) {
      console.error('Id already has a popup calendar, skipping the second one: ',
                    elementId);
    }
    else {
      drupalSettings.calendar_systems.pd[elementId] = pd;
    }
  }

  Drupal.behaviors.calendar_systems = {
    attach: function attach(context, settings) {
      $(context).find('input[data-calendar-systems-calendar]')
                .once('calendarSystemsPicker')
                .each(function () {
                  var $input = $(this);
                  var c = $input.attr('data-calendar-systems-calendar');
                  if (c !== 'persian' && c !== 'gregorian') {
                    return;
                  }
                  var sett = {
                    autoClose: true,
                    format: $input.data('calendar-systems-format')
                                  .replace('Y', 'YYYY')
                                  .replace('m', 'MM')
                                  .replace('d', 'DD'),
                    position: 'auto',
                    onlySelectOnDate: true,
                    calendarType: c,
                    calendar: {
                      persian: {
                        locale: getLangcode(),
                        showHint: true,
                      },
                      gregorian: {
                        locale: getLangcode(),
                        showHint: true,
                      },
                    },
                    timePicker: {
                      enabled: false,
                    },
                    toolbox: {
                      calendarSwitch: {
                        enabled: false,
                      },
                    },
                    initialValueType: c,
                    initialValue: false,
                  };
                  storePd($input.attr('id'), $input.persianDatepicker(sett));
                });
    },
  };

})(jQuery, Modernizr, Drupal);
